<?php

namespace Framework\Controllers;
use Framework\Modules\Pixel;
use Framework\Foundation\Helper;

class AjaxController extends BaseController
{

    public function updateCurrencyRates()
    {
        return \Framework\Modules\CurrencyRates::updatRates();
    }

    public function geolocationData() 
    {
        return \Framework\Modules\GeoLocation::getData();
    }

    public function fireMailChimp($request)
    {

        $credentialsFile = sprintf(
                '%s%sstorage%scredentials.json', dirname(dirname(__DIR__)), DIRECTORY_SEPARATOR, DIRECTORY_SEPARATOR
        );

        $credentials = @json_decode(
                        @file_get_contents($credentialsFile), true
        );

        if (
                empty($credentials['mail_chimp']['endpoint']) ||
                empty($credentials['mail_chimp']['username']) ||
                empty($credentials['mail_chimp']['api_key']) ||
                empty($credentials['mail_chimp']['store_id'])
        )
        {
            echo json_encode(array(
                'success' => true,
                'message' => 'Invalid credentials',
            ));
            return;
        }

        $customerData = @$_SESSION['prospect_shipping_data'];

        $data                  = $request->request->all();
        $data['id']            = uniqid();
        $data['opt_in_status'] = true;

        $url = sprintf(
                '%s/3.0/ecommerce/stores/%s/customers', $credentials['mail_chimp']['endpoint'], $credentials['mail_chimp']['store_id']
        );

        $response = $this->httpClient->post(
                $url, [
            'body'    => json_encode($data),
            'headers' => [
                'Authorization' => sprintf(
                        'Basic %s', base64_encode(sprintf(
                                        '%s:%s', $credentials['mail_chimp']['username'], $credentials['mail_chimp']['api_key']
                        ))
                ),
                'Content-Type'  => 'application/json',
            ],
                ]
        );

        return $response->getBody()->getContents();
    }

    public function getPixel()
    {
        $pixel = new Pixel();
        return $pixel->preparePixel('onSubmit');
    }

    public function imageStorage()
    {
        $configFiles = ['config.general','config.offers'];

        foreach ($configFiles as $configJson) 
        {
            $getJson        = Helper::getJsonFileData(STORAGE_PATH, $configJson.'.json');
            $getJsonValue   = json_decode($getJson,true);
            if(!empty($getJsonValue))
            {
                $newValue = $this->replaceImagePath($getJsonValue);
                file_put_contents(STORAGE_PATH.'/'.$configJson.'.json', json_encode($newValue));
            }
        }
        
    }

    public function replaceImagePath(array $configArr, string $path = null) 
    {
        if(empty($path)) $path = 'storage.googleapis.com';
     
        array_walk_recursive($configArr, function (&$configValue, $configKey) use ($path) 
        {
            if (!is_array($configValue) && (preg_match('/'.$path.'/i', $configValue))) 
            {
                $this->storeImage($configValue);
                $configValue = 'images/'.basename($configValue);
            }
        });

        return $configArr;
    }

    public function storeImage(string $configValue)
    {
        $newPath = 'images/'.basename($configValue);
        $content = @file_get_contents($configValue, true); //getting the file content
            
        if ($content != false) 
        {
            $getImage = @file_get_contents($configValue);
            file_put_contents($newPath, $getImage);
        }
    }

}
