<?php

namespace Framework\Controllers;
use Framework\Foundation\Config;

class CronController extends BaseController
{

    protected $header, $form_data, $endpoint, $configData;

    protected function setParams()
    {
        $this->configData = Config::get();
        $this->header['X-License-Key']        = $this->configData['domain']['license'];
        $this->form_data['funnel_identifier'] = $this->configData['funnel']['identifier'];
        $this->form_data['domain_name']       = $this->configData['domain']['name'];
        $this->endpoint                       = $this->configData['uni_api_endpoint'];
    }

    public function updateConfigJson(){
        $slug = !empty($_REQUEST['slug']) ? $_REQUEST['slug'] : '';
        $this->setParams();
        switch($slug)
        {
            case 'shield':
                $this->updateShieldJson();
                break;
            case 'all':
                $this->updateShieldJson();
                break;

            case 'default':
                break;
        }
    }

    public function updateShieldJson()
    {
        $this->endpoint = $this->endpoint . '/update-shield-json';
        $response = $this->callAPI();
        $resp = json_decode($response->getBody()->getContents(),true);
        if($resp['success'])
        {
            $jsonShieldData = json_encode($resp['result']['shield']);
            file_put_contents(STORAGE_PATH.DS.'shield.json',$jsonShieldData);
            echo 'Shield Updated';
        }
        else
        {
            echo $resp['message'];
        }
    }

    protected function callAPI()
    {
        $response = $this->httpClient->post($this->endpoint, [
            'body'    => $this->form_data,
            'headers' => $this->header,
        ]);

        return $response;
    }
}

?>