<?php

namespace Framework\Foundation;

abstract class Event {

    public static function dispatch() {
        
        try {

            $event = new static(...func_get_args());

            $listeners = \Framework\Providers\EventService::getListeners(static::class);
            
            foreach ($listeners as $listener) {
                (new $listener)->handle($event);
            }
        } catch(\Exception $e) {

            if(APP_DEBUG) {
                throw new \Exception('Event: '. $e->getMessage());
            }
        }

    }
}