<?php

namespace Framework\Middleware;

use Closure;
use Framework\Foundation\Config;

class CheckFunnelDisableStatus implements \Framework\Contracts\Middleware
{

    /**
     * Handle an incoming request.
     *
     * @param  Request  $request
     * @param  \Closure  $next
     * @return mixed
     */
    public function handle($request, Closure $next)
    {

        // Funnel hard redirect if it is disable
        $server_name = !empty($_SERVER['SERVER_NAME']) ? $_SERVER['SERVER_NAME'] : 'cms.unify.to';

        $domains = \Framework\Foundation\Helper::prodDevDomains();

        if (Config::get('funnel.disable') == 1 && !in_array($server_name, $domains))
        {
            $nav_url = Config::get('funnel.disable_redirect_url');
            $nav_url = empty($nav_url) ? 'https://www.google.com' : $nav_url;
            if (empty($nav_url))
            {
                header($_SERVER["SERVER_PROTOCOL"] . " 400 Bad Request", true, 400);
            }
            header("Location: " . $nav_url, true, 302);
            exit();
        }

        return $next($request);
    }

}
