<?php

namespace Framework\Models;


class CustomerMeta extends Model {

    protected $table = 'customer_meta';

    protected function migrations() {

        if($this->tableSchema) return $this->tableSchema;

        $query = sprintf( "CREATE TABLE IF NOT EXISTS %s (", $this->table);
        $query .= "`id` INTEGER PRIMARY KEY /*!40101 AUTO_INCREMENT */, ";
        $query .= "`customer_id` INTEGER, ";
        $query .= "`meta_key` varchar(100) DEFAULT NULL, ";
        $query .= "`meta_value` TEXT DEFAULT NULL)";

        return $query;
    }

    public function all($customerId) {

        $metas = $this->findByParams([
            'customer_id' => $customerId
        ]);

        try {
            return $metas->mapWithKeys(function($item) {
                return [$item->meta_key => $item->meta_value];
            });
        } catch (\Exception $e) {
            return collect([]);
        }
    }

}