<?php

namespace Framework\Modules\Crm\Middleware\NewProspect;

use Closure;
use Framework\Foundation\Config;

class FilterFormData implements \Framework\Contracts\Middleware {

    public function handle($request, Closure $next)
    {
        $formData = $request->json;
        $shield = Config::get('shield');
        $error_message = Config::get('error_messages');

        if (!empty($formData['agreeCheckbox'])) unset($formData['agreeCheckbox']);

        if(!empty($formData['cc_number']) && in_array($formData['cc_number'], $shield['card']))
        {
            return pre_response_array(null, false, array('response_message' => $error_message['card_blocked']));
        }

        $_SESSION['prospect_shipping_data'] = $formData;

        $request->json = $formData;
        return $next($request);
    }
}