<?php

namespace Framework\Modules\Crm\Middleware;

use Closure;
use Framework\Foundation\Config;

class Shield implements \Framework\Contracts\Middleware
{

    public function handle($request, Closure $next)
    {
        $formData = $request->json;
        $shield = Config::get('shield');
        $error_message = Config::get('error_messages');

        if(!empty($formData['email']) && in_array($formData['email'], $shield['email']))
        {
            return pre_response_array(null, false, array('response_message' => $error_message['email_blocked']));
        }

        if(!empty($formData['phone']) && in_array($formData['phone'], $shield['phone']))
        {
            return pre_response_array(null, false, array('response_message' => $error_message['phone_blocked']));
        }
        
        if(in_array($_SERVER['REMOTE_ADDR'], $shield['ip']))
        {
            return pre_response_array(null, false, array('response_message' => $error_message['ip_blocked']));
        }

        return $next($request);
    }
}
