<?php

namespace Framework\Modules\Crm\Middleware\Upsell;

use Closure;
use Framework\Foundation\Config;

class FilterFormData implements \Framework\Contracts\Middleware {

    public function handle($request, Closure $next)
    {
        $formData = $request->json;

        $request->insureshipCheckbox = 1;
        if (isset($formData['upsellData']['insureshipCheckbox']))
        {
            $request->insureshipCheckbox = $formData['upsellData']['insureshipCheckbox'];
            unset($formData['upsellData']['insureshipCheckbox']);
        }

        $prospectId = isset($formData['queryStrings']['prospect_id']) ? $formData['queryStrings']['prospect_id'] : '';
        $customerId = isset($formData['queryStrings']['customer_id']) ? $formData['queryStrings']['customer_id'] : '';
        $upsellData = [];
        if (!empty($_SESSION['full_order_data']))
        {
            $upsellData = $_SESSION['full_order_data'];
        }

        if (Config::get('payment_provider.api_type') == 'konnektive')
        {
            $upsellData['queryStrings'] = $formData['queryStrings'];
        }

        $upsellData['order_type']  = 'UpsellOrder';
        $upsellData['prospect_id'] = $prospectId;
        $upsellData['customer_id'] = $customerId;

        $request->json = $formData;
        $request->upsellData = $upsellData;
        return $next($request);
    }
}