<?php

namespace Framework\Modules;
use Framework\Foundation\Config;
use Framework\Foundation\Helper;
use GuzzleHttp\Client;

class MaxMind
{
    private $device;
    private $isFraud = false;

    public function __construct($end_point,$account_id,$license_key)
    {
        $this->accountid    = $account_id;
        $this->licensekey   = $license_key;
        $this->endpoint     = $end_point;
    }

    public function getMaxMindFraudResponse($shipping_data,$billing_data){
        
        $this->setDeviceData();
        
        $curlData['device'] = $this->device;
        $curlData['shipping'] = $shipping_data;

        if(!empty($billing_data))
        {
            $curlData['billing'] = $billing_data;
        }
        $response = $this->callApi(json_encode($curlData));

        return $response;
    }

    
    private function setDeviceData()
    {
        $this->device['ip_address'] = Helper::getIP();
        $this->device['user_agent'] = $_SERVER['HTTP_USER_AGENT'];
    }

    private function callApi($data)
    {
        $url         = $this->endpoint;
        $headers = [
            'Authorization' => 'Basic '. base64_encode($this->accountid.":". $this->licensekey),        
            'Accept'        => 'application/json',
            "Content-Type"  => "application/vnd.maxmind.com-minfraud-insights+json; charset=UTF-8; version=2.0"
        ];        
    
        $client = new Client();    
    
        $client->setDefaultOption('headers', $headers);
        $client->setDefaultOption('verify', false);
        //$client->setDefaultOption('debug', fopen('php://stderr', 'w'));
    
        $guzzle_response = $client->post($url, array('body'=> $data))->getBody(true)->getContents();
    
        $response = json_decode($guzzle_response,true);
        
        return $response;
    }
}