<?php
namespace Framework\Modules\Migration;

use Framework\Foundation\Helper;

class OfferConfig {

    private static $funnelJsonData;
    private static $offerConfigs;
    
    public static function migrate() {
        static::$funnelJsonData = Helper::getJsonFileData(STORAGE_PATH, 'funnel.json');
    
        if(static::$funnelJsonData->isEmpty()) return;

        static::mapGeneral();

        Helper::createFileifNotExists('config.offers.json', STORAGE_PATH, json_encode(static::$offerConfigs, JSON_PRETTY_PRINT));
    }

    private static function mapGeneral() {

        static::$offerConfigs = static::$funnelJsonData->get('offer_details', []);
        static::$offerConfigs['enable_upsells'] = static::$funnelJsonData->get('enable_upsells', 0);
        static::$offerConfigs['split_charge'] = static::$funnelJsonData->get('split_charge', 0);
    }

}



