<?php

namespace Framework\Providers;

/**
 * @Example 
 *   TestOrderPlaceEvent::dispatch([
 *      'orderId' => 11111,
 *      'orderTotal' => 99.99
 *   ]);
 */
class EventService
{

    /**
     * We can add event listeners for our app, the index name is the event class and the inside the index, we can add respective listeners.
     * @var $listeners
     */
    public static $listeners = [
        \Framework\Events\TestOrderPlaceEvent::class => [
            \Framework\Listeners\TestSendOrderPlaceEmail::class
        //\Framework\Listeners\AnotherExampleListener::class
        ],
        \Framework\Events\NewOrderPlaced::class => [
            \Framework\Listeners\HandleSpamCustomer::class,
        ],
        \Framework\Events\UpsellOrderPlaced::class => [
            \Framework\Listeners\HandleSpamCustomer::class,
        ],
        \Framework\Events\DatabaseEvent::class => [
            \Framework\Listeners\Models\Create::class,
            \Framework\Listeners\Models\Update::class,
            \Framework\Listeners\Models\Delete::class,
            \Framework\Listeners\Models\General::class,
        ]
    ];

    public static function getListeners($classFullName)
    {
        return array_get(static::$listeners, $classFullName, []);
    }

}
