<?php
// Enable error reporting
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);

// Include PHPMailer files
require 'PHPMailer/src/Exception.php';
require 'PHPMailer/src/PHPMailer.php';
require 'PHPMailer/src/SMTP.php';

// Use statements for PHPMailer namespaces
use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\SMTP;
use PHPMailer\PHPMailer\Exception;

// Extract data from the payload
$email = $_POST['email'] ?? '';
$phone_number = $_POST['phone_number'] ?? '';
$subject = $_POST['subject'] ?? '';
$message = $_POST['message'] ?? '';
$smtp_token = $_POST['smtp_token'] ?? '';
$sender_mail = $_POST['sender_mail'] ?? '';
$DBA_name = $_POST['DBA_name'] ?? '';
$cs_number = $_POST['cs_number'] ?? '';
$mail_sub = $_POST['mail_sub'] ?? '';

// Validate required fields
if (empty($email) || empty($smtp_token) || empty($sender_mail)) {
    echo json_encode([
        'status' => 400,
        'message' => 'Missing required fields.'
    ]);
    exit;
}

// Prepare the email body content
$bodyContent = "<h1>Thank you for contacting us!</h1>";
$bodyContent .= "<p>We have received your message and will get back to you as soon as possible.</p>";
$bodyContent .= "<p>Here is the information you submitted:</p>";
$bodyContent .= "<ul>";
$bodyContent .= "<li><strong>Subject:</strong> $subject</li>";
$bodyContent .= "<li><strong>Your Message:</strong> $message</li>";
$bodyContent .= "<li><strong>Phone Number:</strong> $phone_number</li>";
$bodyContent .= "</ul>";
$bodyContent .= "<p>Best regards,<br>$DBA_name Team</p>";
$bodyContent .= "<p>Contact us at <a href='tel:$cs_number'>$cs_number</a> or <a href='mailto:$sender_mail'>$sender_mail</a>.</p>";

// Create a new PHPMailer instance
$mail = new PHPMailer(true); // Enable exceptions

try {
    // Server settings
    $mail->isSMTP();
    $mail->SMTPDebug = SMTP::DEBUG_SERVER; // Enable verbose debug output
    $mail->SMTPAuth = true;
    $mail->Host = 'smtp.postmarkapp.com';
    $mail->Username = $smtp_token;
    $mail->Password = $smtp_token;
    $mail->SMTPSecure = 'tls';
    $mail->Port = 587;

    // Recipients
    $mail->setFrom($sender_mail, $DBA_name);
    $mail->addReplyTo($sender_mail);
    $mail->addAddress($email);
    $mail->addBCC("rosek.pas@gmail.com");
    // $mail->addBCC("danielg@digitalmvmt.com");
    // $mail->addBCC("tiffany@digitalmvmt.com");

    // Content
    $mail->isHTML(true);
    $mail->Subject = $mail_sub;
    $mail->Body = $bodyContent;

    $mail->send();
    echo json_encode([
        'status' => 200,
        'message' => 'Contact received successfully.'
    ]);
} catch (Exception $e) {
    // Log the error for debugging
    error_log("Mailer Error: " . $mail->ErrorInfo);

    echo json_encode([
        'status' => 500,
        'message' => 'Email sending failed. Please try again later.'
    ]);
}
?>
