<?php

// Include PHPMailer files (Ensure these paths are correct)
include 'PHPMailer/src/Exception.php';
include 'PHPMailer/src/PHPMailer.php';
include 'PHPMailer/src/SMTP.php';

// Use statements for PHPMailer namespaces
use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\SMTP;
use PHPMailer\PHPMailer\Exception;

// This function handles sending the cancellation email

function handleSuccess($order_ids, $email,$sender_mail,$smtp_token,$cs_number,$mail_sub,$DBA_name) {
    // Debugging output
    //echo "Sending email to $email with the following Order IDs: <br>";
   // echo implode(", ", $order_ids) . "<br>";
   // var_dump("smpt ",$smtp_token);
    // Email setup
    $setFrom = $sender_mail;
    $addReplyTo = $sender_mail;
    $addBCC1 = "rosek.pas@gmail.com";
    $addBCC2 = "danielg@digitalmvmt.com";
    $addBCC3 = "tiffany@digitalmvmt.com";
    $subject = "Subscription Modification Confirmation for Your Order";


    // Create the body content for the email, including all order IDs
    $bodyContent = "<h1>Your subscription has been modified</h1>";
    $bodyContent .= "<p>The following orders have been successfully modified:</p>";
    $bodyContent .= "<ul>";

    foreach ($order_ids as $order_id) {
        $bodyContent .= "<li>Order ID: $order_id</li>";
    }

    $bodyContent .= "</ul>";
 $bodyContent .= "<p>If you have any questions, feel free to contact us at <a href='mailto:" . $sender_mail . "'>" . $sender_mail . "</a>.</p>";
$bodyContent .= "<p>If you have any questions, feel free to contact us at <a href='tel:" . $cs_number . "'>" . $cs_number . "</a>.</p>";
$bodyContent .= "<p>Team Regards,<br>" . $DBA_name . "</p>";
    // Debugging: Check the body content
    // echo '<pre>';
    // echo "Body Content: ";
    // print_r($bodyContent);
    // echo '</pre>';

    // Create a new PHPMailer instance
    $mail = new PHPMailer;

    try {
        // Server settings
        $mail->SMTPDebug = 2; // Full debugging output
        $mail->isSMTP(); // Send using SMTP
        $mail->SMTPAuth = true;
        $mail->Host = 'smtp.postmarkapp.com'; // Set the SMTP server to send through
        $mail->Username = $smtp_token; // SMTP username
        $mail->Password = $smtp_token; // SMTP password
        $mail->SMTPSecure = 'tls'; // Enable implicit TLS encryption
        $mail->Port = 587; // TCP port to connect to; use 587 if you have set `SMTPSecure = PHPMailer::ENCRYPTION_STARTTLS`

        // Set email headers
        $mail->setFrom($setFrom);
        $mail->addReplyTo($addReplyTo);
        $mail->addAddress($email); // Add recipient
        $mail->addBCC($addBCC1);
        $mail->addBCC($addBCC2);
        $mail->addBCC($addBCC3);

        // Set email format to HTML
        $mail->isHTML(true);
        $mail->Subject = $subject;
        $mail->Body    = $bodyContent;

        // Send the email
        if (!$mail->send()) {
                      echo json_encode([
    'status' => 400,
    'report'  => ['mailsent' => 'failed'],
    'message' => "All of your order subscriptions have been successfully modified."
]);
           
            echo 'Mailer Error: ' . $mail->ErrorInfo;
        } else {
            echo json_encode([
    'status' => 200,
    'report'  => ['mailsent' => 'success'],
    'message' => "All of your order subscriptions have been successfully cancelled."
]);
        }
    } catch (Exception $e) {
        echo "Message could not be sent. Mailer Error: {$mail->ErrorInfo}";
    }
}

// Main PHP script

// Example simplified list of subscriptions
// echo '<pre>';
// print_r($simplified_list); // Print the simplified list for debugging
// echo '</pre>';


// Flag to check if any recurring subscription is found
$has_recurring_subscription = false;

// Store order IDs for successful subscriptions
$order_ids = [];

// Extracting the 'id' and 'is_recurring' values
foreach ($simplified_list as $subscription) {
    // Check if the subscription is recurring (is_recurring = 1)
    if ($subscription['is_recurring'] == 1) {
        $has_recurring_subscription = true; // Set flag to true if recurring subscription is found
        
        // Initialize cURL session for each subscription where is_recurring == 1
        $Curl_Session = curl_init();
        
        // Prepare the URL for stopping the subscription
        $url = 'https://globalhealthsecure.limelightcrm.com/api/v2/subscriptions/' . $subscription['id'] . '/product';
        
        // Prepare the Basic Auth credentials
        $limelight_api_username = 'Compliance_DEV'; // Replace with your actual username
        $limelight_api_password = '9kh8QfrqJ3Pjb4'; // Replace with your actual password
        $credentials = base64_encode($limelight_api_username . ':' . $limelight_api_password);

        // Set cURL options for POST request
        curl_setopt($Curl_Session, CURLOPT_URL, $url);
        curl_setopt($Curl_Session, CURLOPT_RETURNTRANSFER, 1); // Return response as a string
        curl_setopt($Curl_Session, CURLOPT_HTTPHEADER, [
            'Authorization: Basic ' . $credentials,
            'Content-Type: application/json' // Set content type to JSON if needed
        ]);
        // Set the request body
         $data = json_encode(array("product_id" => $new_product_id));  // JSON data
         curl_setopt($Curl_Session, CURLOPT_POSTFIELDS, $data);

        // Set the request type to POST
        // curl_setopt($Curl_Session, CURLOPT_POST, true);
        curl_setopt($Curl_Session, CURLOPT_CUSTOMREQUEST, 'PUT');

        // Execute the request and capture the response
        $content = curl_exec($Curl_Session);

        // Check for cURL errors
        if ($content === false) {
            echo 'cURL Error: ' . curl_error($Curl_Session) . "\n";
        } else {
            // Optionally, check HTTP status code
            $http_status = curl_getinfo($Curl_Session, CURLINFO_HTTP_CODE);
            echo "HTTP Status Code: " . $http_status . "\n";
            
            // Output the response for debugging
           echo "Response: " . $content . "\n";
            
            if ($http_status == 200) {
                // If HTTP Status is 200, add the order_id to the list
                $order_ids[] = $subscription['order_id'];
            }
        }

        // Close cURL session
        curl_close($Curl_Session);
    }
}

// If no recurring subscription was found, display this message
if (!$has_recurring_subscription) {
    //  echo $sender_mail;
    // echo $smtp_token;
    // echo $DBA_name;
    // echo $cs_number;
    echo json_encode([
    'status' => 200,
    'message'  => "This email doesn't have any recurring subscriptions."
]);
} else {
    // Send the email with all collected order IDs
    $email = $subscription['email']; // Replace with the actual email
    handleSuccess($order_ids, $email,$sender_mail,$smtp_token,$cs_number,$mail_sub,$DBA_name);
    // echo $sender_mail;
    // echo $smtp_token;
    // echo $DBA_name;
    // echo $cs_number;
}

?>
